---
title: Upgrade
slug: Web/HTTP/Headers/Upgrade
tags:
  - HTTP
  - HTTP Header
  - Upgrade
---
<p>{{HTTPSidebar}}</p>

<p>The HTTP 1.1 (only) <code>Upgrade</code> header can be used to upgrade an already established client/server connection to a different protocol (over the same transport protocol). For example, it can be used by a client to upgrade a connection from HTTP 1.1 to HTTP 2.0, or an HTTP or HTTPS connection into a WebSocket.</p>

<div class="notecard warning">
<p>HTTP/2 explicitly disallows the use of this mechanism/header; it is specific to HTTP/1.1.</p>
</div>

<table class="properties">
	<tbody>
		<tr>
			<th scope="row">Header type</th>
			<td>{{Glossary("General header")}}</td>
		</tr>
		<tr>
			<th scope="row">{{Glossary("Forbidden header name")}}</th>
			<td>yes</td>
		</tr>
	</tbody>
</table>

<h2 id="Overview">Overview</h2>

<p>The <code>Upgrade</code> header field may be used by clients to invite a server to switch to one (or more) of the listed protocols, in descending preference order.</p>

<p>For example, the client might send a <code>GET</code> request as shown, listing the preferred protocols to switch to (in this case "example/1" and "foo/2"):</p>

<pre class="notranslate">GET /index.html HTTP/1.1
Host: www.example.com
Connection: upgrade
Upgrade: example/1, foo/2</pre>

<div class="notecard note">
<p><strong>Note</strong>: <code>Connection: upgrade</code> must be set whenever <code>Upgrade</code> is sent.</p>
</div>

<p>The server can choose to ignore the request, for any reason, in which case it should just respond as though the <code>Upgrade</code> header had not been sent (for example, with a  {{HTTPStatus(200, "200 OK")}}).</p>

<p>If the server decides to upgrade the connection, it must:</p>

<ol>
	<li>Send back a {{HTTPStatus(101, "101 Switching Protocols")}} response status with an <code>Upgrade</code> header that specifies the protocol(s) being switched to. For example:

	<pre class="notranslate"><code>HTTP/1.1 101 Switching Protocols
Upgrade: foo/2
Connection: Upgrade</code></pre>
	</li>
	<li>Send a response to the original request <em>using the new protocol</em> (the server may only switch to a protocol with which it can complete the original request).</li>
</ol>

<p>A server may also send the header as part of a {{HTTPStatus("426")}} <code>Upgrade Required</code> response, to indicate that the server won't perform the request using the current protocol, but might do so if the protocol is changed. The client can then request a protocol change using the process above.</p>

<p>More detail and examples are provided in the topic <a href="/en-US/docs/Web/HTTP/Protocol_upgrade_mechanism">Protocol upgrade mechanism</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="notranslate">Connection: upgrade
Upgrade: <em>protocol_name</em>[<strong>/</strong><em>protocol_version</em>]
</pre>

<p>Notes:</p>

<ul>
	<li>The {{HTTPHeader("Connection")}} header with type <code>upgrade</code> must <em>always</em> be sent with the <code>Upgrade</code> header (as shown above).</li>
	<li>Protocols are listed, comma-separated, in order of descending preference. Protocol version is optional. For example:
	<pre class="notranslate">  Connection: upgrade
  Upgrade: a_protocol/1, example ,another_protocol/2.2
</pre>
	</li>
</ul>

<h2 id="Directives">Directives</h2>

<dl>
	<dt>any comma-separated list protocol names (each with optional protocol version)</dt>
	<dd>One or more protocol names with optional version ("/" separated). The protocols are listed in order of descending preference.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="notranslate">Connection: upgrade
Upgrade: HTTP/2.0, SHTTP/1.3, IRC/6.9, RTA/x11
</pre>

<pre class="notranslate">Connection: Upgrade
Upgrade: websocket
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{RFC(7230, "Hypertext Transfer Protocol (HTTP/1.1): Message Syntax and Routing",6.7)}}</td>
			<td>IETF RFC</td>
			<td></td>
		</tr>
		<tr>
			<td>{{RFC("7231", "426 Upgrade Required" , "6.5.15")}}</td>
			<td>IETF RFC</td>
			<td></td>
		</tr>
		<tr>
			<td>{{RFC(7540, "Hypertext Transfer Protocol Version 2 (HTTP/2)","8.1.1")}}</td>
			<td>IETF RFC</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Upgrade")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/HTTP/Protocol_upgrade_mechanism">Protocol upgrade mechanism</a></li>
	<li>{{HTTPStatus("101")}} <code>Switching Protocol</code></li>
	<li>{{HTTPStatus("426")}} <code>Upgrade Required</code></li>
	<li>{{HTTPHeader("Connection")}}</li>
</ul>
